﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Threading;


namespace Thread2 {
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {
        public MainWindow() {
            InitializeComponent();
        }

        private void bnStart1_Click(object sender, RoutedEventArgs e) {
            TestThread prog = new TestThread();

            ThreadStart ts1, ts2;
            ts1 = new ThreadStart(prog.run1);
            // ts2 = new ThreadStart(prog.run2);

            Thread t1, t2;
            t1 = new Thread( ts1 );
            t2 = new Thread( prog.run2 );  // Vereinfachte Übergabe
            t1.Start();
            t2.Start();
            
        }

        private void bnSumme_Click(object sender, RoutedEventArgs e) {
            int summe = 0;
            for (int i = 1; i <= 1000; i++) summe += i;
            MessageBox.Show("Ergebnis: " + summe);

            ThreadSumme prog1 = new ThreadSumme(1,500);
            ThreadSumme prog2 = new ThreadSumme(501,1000);

            Thread t1, t2;
            t1 = new Thread(prog1.run);
            t2 = new Thread( prog2.run );  // Vereinfachte Übergabe
            t1.Start();
            t2.Start();
            t1.Join();
            t2.Join();
            MessageBox.Show("Ergebnis: " + ThreadSumme.summe);
        }

        private void bnSumme2_Click(object sender, RoutedEventArgs e) {
            int summe = 0;
            for (int i = 1; i <= 1000; i++) summe += i;

            ThreadSumme2 prog1 = new ThreadSumme2(1, 500);
            ThreadSumme2 prog2 = new ThreadSumme2(501, 1000);

            Thread t1, t2;
            t1 = new Thread(prog1.run);
            t2 = new Thread(prog2.run);  // Vereinfachte Übergabe
            ThreadSumme2.summe = 0;
            t1.Start();
            t2.Start();
            t1.Join();
            t2.Join();
            MessageBox.Show("Ergebnis summe: " + summe + "\r\n" + "Ergebnis Thread: " + ThreadSumme2.summe);
        }

        private void bnMutex_Click(object sender, RoutedEventArgs e) {
            int summe = 0;
            for (int i = 1; i <= 1000; i++) summe += i;

            Mutex mutex = new Mutex(false, "Thread_Summe_Mutex");

            ThreadSummeMutex prog1 = new ThreadSummeMutex(1, 500);
            ThreadSummeMutex prog2 = new ThreadSummeMutex(501, 1000);

            Thread t1, t2;
            t1 = new Thread(prog1.run);
            t2 = new Thread(prog2.run);  // Vereinfachte Übergabe
            ThreadSummeMutex.summe = 0;
            t1.Start();
            t2.Start();
            t1.Join();
            t2.Join();
            MessageBox.Show("Ergebnis summe: " + summe + "\r\n" + "Ergebnis Thread: " + ThreadSummeMutex.summe);
            mutex.Close();
            mutex = null;

        }

        private void bnSemaphore_Click(object sender, RoutedEventArgs e) {
            int summe = 0;
            for (int i = 1; i <= 1000; i++) summe += i;

            Semaphore crit = new Semaphore(1, 1, "Thread_Summe_Semaphore");  // initialCount, maximalCount

            ThreadSummeSemaphore prog1 = new ThreadSummeSemaphore(1, 500);
            ThreadSummeSemaphore prog2 = new ThreadSummeSemaphore(501, 1000);

            Thread t1, t2;
            t1 = new Thread(prog1.run);
            t2 = new Thread(prog2.run);  // Vereinfachte Übergabe
            ThreadSummeSemaphore.summe = 0;
            t1.Start();
            t2.Start();
            t1.Join();
            t2.Join();
            MessageBox.Show("Ergebnis summe: " + summe + "\r\n" + "Ergebnis Thread: " + ThreadSummeSemaphore.summe);
            crit.Close();
            crit = null;
        }
    }
}
